package xyz.etztech.minecraftmanager.tasks;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import xyz.etztech.minecraftmanager.MCMUtil;
import xyz.etztech.minecraftmanager.MinecraftManager;

import java.io.File;
import java.io.FileWriter;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

public class ReportRunnable implements Runnable {
    private String calledBy;

    public ReportRunnable(String calledBy) {
        this.calledBy = calledBy;
    }

    @Override
    public void run() {
        MCMUtil.staffMessage("A report has been started by " + calledBy + ".");
        MinecraftManager.setReportRunning(true);
        MinecraftManager.setReportStop(false);
        boolean interrupted = false;

        JsonObject reportJson = new JsonObject();

        dance: // Is it worth the joke? We may never know...
        for (World world : Bukkit.getServer().getWorlds()) {
            Map<String, Integer> countMap = new HashMap<>();
            if (MinecraftManager.getReportStop()) {
                interrupted = true;
                break;
            }
            Map<String, JsonArray> entitiesMap = new HashMap<>();
            JsonArray playersJson = new JsonArray();

            for (Entity entity : world.getEntities()) {
                if (MinecraftManager.getReportStop()) {
                    interrupted = true;
                    break dance;
                }
                JsonObject entityJson = new JsonObject();
                Location location = entity.getLocation();
                entityJson.addProperty("x", location.getBlockX());
                entityJson.addProperty("y", location.getBlockY());
                entityJson.addProperty("z", location.getBlockZ());
                if (entity instanceof Player) {
                    entityJson.addProperty("name", entity.getName());
                    playersJson.add(entityJson);
                } else {
                    String type = entity.getType().name();
                    JsonArray jsonArray = entitiesMap.get(type);
                    if (jsonArray == null) {
                        jsonArray = new JsonArray();
                    }
                    jsonArray.add(entityJson);
                    entitiesMap.put(type, jsonArray);
                    if (countMap.containsKey(type)) {
                        countMap.put(type, countMap.get(type) + 1);
                    } else {
                        countMap.put(type, 1);
                    }
                }
            }
            JsonObject worldJson = new JsonObject();
            JsonObject entitiesJson = new JsonObject();
            for (String type : entitiesMap.keySet()) {
                entitiesJson.add(type, entitiesMap.get(type));
            }
            worldJson.add("entities", entitiesJson);
            worldJson.add("players", playersJson);
            JsonObject countJson = new JsonObject();
            for (String type : countMap.keySet()) {
                countJson.addProperty(type, countMap.get(type));
            }
            worldJson.add("counts", countJson);
            reportJson.add(world.getName(), worldJson);
            reportJson.addProperty("time", new Date().getTime()/1000);
        }
        File report = new File(Bukkit.getPluginManager().getPlugin("MinecraftManager").getDataFolder().getAbsolutePath() + "/report.json");
        try {
            if (!report.exists()) {
                report.createNewFile();
            }
            FileWriter writer = new FileWriter(report);
            writer.write(reportJson.toString());
            writer.close();
        } catch (Exception ex) {
            Bukkit.getConsoleSender().sendMessage(ChatColor.RED + "Could not generate a report...something went wrong.");
        }
        MinecraftManager.setReportStop(false);
        MinecraftManager.setReportRunning(false);
        if (interrupted) {
            MCMUtil.staffMessage("The report started by " + calledBy + " has been stopped.");
        } else {
            MCMUtil.staffMessage("The report started by " + calledBy + " has finished generating.");
        }
    }
}
